#!/bin/bash
#
# Skrypt do testowania 2. zadania zaliczeniowego
#
# Sposób użycia
# ./testuj.sh ROZWIAZANIE.c
#
# @author: TW
# @date: 2024-12-11
#
function err() {
    echo "ERR: $1"
    exit 1
}

if [ -z "$1" ] ; then err "./testuj.sh plik_c"; fi
if [ ! -e "$1" ] ; then err "plik $1 nie istnieje"; fi
GCC=gcc
if [ -e /opt/homebrew/bin/gcc-14 ] ; then
    GCC=gcc-14
fi

SRC="$1"
DESTDIR="wyniki"
read -r -d '' TESTS << EOM
testy/test1.in 1
testy/test2.in 1
testy/test3.in 2
testy/test4.in 3
testy/test5.in 5
testy/test6.in 8
testy/test7.in 13
testy/test8.in 21
testy/test9.in 34
testy/test10.in 55
EOM

rm -rf "$DESTDIR"
mkdir -p "$DESTDIR"
echo "$TESTS" | while read -r line ; do
    fn=`echo $line | cut -f 1 -d ' '`
    n=`echo $line | cut -f 2 -d ' '`

    test_name=`basename ${fn%.in}`
    expected=${fn%.in}.out
    compiled="${DESTDIR}/sol-${n}.e"
    out="${DESTDIR}/${test_name}.out"

    echo -n "${test_name} (n=${n}).. "
    
    ${GCC} @opcje -DN=${n} "${SRC}" -o "${compiled}" || err "błąd kompilacji"
    
    "$compiled" < "$fn" > "${out}"

    if [ $? -ne 0 ] ; then
        echo "RUNTIME ERROR"
    else
        if diff -q "${out}" "${expected}" > /dev/null ; then
            echo "OK"
        else
            echo "WRONG ANSWER"
        fi
    fi
done
